package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.bo.CourseMenuExamAddBo;
import com.zhongzheng.modules.course.bo.CourseMenuExamEditBo;
import com.zhongzheng.modules.course.bo.CourseMenuExamQueryBo;
import com.zhongzheng.modules.course.domain.CourseMenuExam;
import com.zhongzheng.modules.course.mapper.CourseMenuExamMapper;
import com.zhongzheng.modules.course.mapper.CourseMenuMapper;
import com.zhongzheng.modules.course.service.ICourseMenuExamService;
import com.zhongzheng.modules.course.vo.CourseMenuExamVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 课程目录关联卷Service业务层处理
 *
 * @author hjl
 * @date 2021-11-17
 */
@Service
public class CourseMenuExamServiceImpl extends ServiceImpl<CourseMenuExamMapper, CourseMenuExam> implements ICourseMenuExamService {

    @Autowired
    private CourseMenuExamMapper courseMenuExamMapper;

    @Override
    public CourseMenuExamVo queryById(Long id){
        CourseMenuExam db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, CourseMenuExamVo.class);
    }

    @Override
    public List<CourseMenuExamVo> getList(CourseMenuExamQueryBo bo) {
        return courseMenuExamMapper.getList(bo);
    }

    @Override
    public List<CourseMenuExamVo> queryList(CourseMenuExamQueryBo bo) {
        LambdaQueryWrapper<CourseMenuExam> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getCourseId() != null, CourseMenuExam::getCourseId, bo.getCourseId());
        lqw.eq(bo.getModuleId() != null, CourseMenuExam::getModuleId, bo.getModuleId());
        lqw.eq(bo.getChapterId() != null, CourseMenuExam::getChapterId, bo.getChapterId());
        lqw.eq(bo.getSectionId() != null, CourseMenuExam::getSectionId, bo.getSectionId());
        lqw.eq(bo.getType() != null, CourseMenuExam::getType, bo.getType());
        lqw.eq(bo.getExamId() != null, CourseMenuExam::getExamId, bo.getExamId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CourseMenuExamVo> entity2Vo(Collection<CourseMenuExam> collection) {
        List<CourseMenuExamVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CourseMenuExamVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<CourseMenuExam> page = (Page<CourseMenuExam>)collection;
            Page<CourseMenuExamVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(CourseMenuExamAddBo bo) {
        CourseMenuExam add = BeanUtil.toBean(bo, CourseMenuExam.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(CourseMenuExamEditBo bo) {
        CourseMenuExam update = BeanUtil.toBean(bo, CourseMenuExam.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(CourseMenuExam entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
